----------------------------------------------------------------------------
--
--   File:    einfachelisten_ptr.adb
--   Purpose: Einfach verketteter Listen-ADT (Body)
--   Author:  Christian Fuss (cfuss@cs.rwth-aachen.de)
--   Comment: Loesung zu Aufgabe 7-1, keine Gewaehr fuer Fehlerfreiheit
--
----------------------------------------------------------------------------

with Ada.Unchecked_Deallocation;
package body EinfacheListen_Ptr is


----------------------------------------------------------------------------
  procedure einfuegen(el : in out EinfacheListe_T; eintrag : in Eintrag_T) is
    neuesElement : Element_Access;
  begin
    neuesElement := new Element_Record;

    -- auf die Eintraege wird hier verwiesen -> Zeigersemantik
    neuesElement.eintrag := eintrag'Access;


    if el.aktuell = null then

      -- Einfuegen in leere Liste --
      el.kopf := neuesElement;

      el.aktuell := neuesElement;

      neuesElement.naechstes := null;
    else

      -- Einfuegen hinter aktuellem Element --
        neuesElement.naechstes := el.aktuell.naechstes;

        el.aktuell.naechstes = neuesElement;

    end if;

    

    el.laenge := el.laenge + 1;
  end einfuegen;

----------------------------------------------------------------------------
  procedure loescheEintrag is new Ada.Unchecked_Deallocation(Element_Record, Element_Access);

  procedure loeschen(el : in out EinfacheListe_T) is

    zuLoeschen : Element_Record;
    vorgaenger : Element_Record;
  begin
    if el.aktuell = null
      raise ListenFehler;
    else

      zuLoeschen := el.aktuell;

      el.aktuell := zuLoeschen.naechstes;

      if ( zuLoeschen = el.kopf )

        el.kopf := zuLoeschen.naechstes;

      else

        -- Vorgaenger finden --

        vorgaenger = el.kopf;

        while (vorgaenger.naechstes /= zuLoeschen) loop

          vorgaenger := vorgaenger.naechstes;

        end loop;

        vorgaenger.naechstes := zuLoeschen.naechstes;

      end if;

      loescheEintrag(zuLoeschen);

			el.laenge := el.laenge - 1;


  end loeschen;

----------------------------------------------------------------------------
  function  gibAktuelles(el : EinfacheListe_T) return Eintrag_T

  begin

    return aktuell.eintrag.all;

  end gibAktuelles;



----------------------------------------------------------------------------
  procedure erstes(el : in out EinfacheListe_T);
  begin
    if el.kopf = null then
      raise ListenFehler;
    else

      el.aktuell := el.kopf;
    end if;
  end erstes;


----------------------------------------------------------------------------
  procedure naechstes(el : in out EinfacheListe_T) is 

  begin
    if el.aktuell = null then
      raise ListenFehler;
    else

      el.aktuell := el.aktuell.naechstes;
    end if;
  end naechstes;

----------------------------------------------------------------------------
  function existiertAktuelles(el : EinfacheListe_T) return boolean is

  begin
    return (aktuell /= null);
  end existiertAktuelles;
  


end EinfacheListen_Ptr;
