----------------------------------------------------------------------------
--
--   File:    einfachelisten_ptr.ads
--   Purpose: Einfach verketteter Listen-ADT (Spezifikation)
--   Author:  Christian Fuss (cfuss@cs.rwth-aachen.de)
--   Comment: Loesung zu Aufgabe 7-1, keine Gewaehr fuer Fehlerfreiheit
--
----------------------------------------------------------------------------

with Eintraege;
use  Eintraege;
package EinfacheListen_Ptr is
  type EinfacheListe_T is private;

  procedure einfuegen(el : in out EinfacheListe_T; Eintrag : in Eintrag_T);
  procedure loeschen(el : in out EinfacheListe_T);

  procedure erstes(el : in out EinfacheListe_T);
  procedure naechstes(el : in out EinfacheListe_T);

  function  existiertAktuelles(el : EinfacheListe_T) return boolean;
  -- Um die Verwirrung zu vollenden, habe ich die oeffentliche Schnittstelle der
  -- Zeiger-Variante nun identisch gestaltet mit der Variablen-Variante (dazu muss
  -- im Body mit dem .all-Attribut explizit dereferenziert werden)
  function  gibAktuelles(el : EinfacheListe_T) return Eintrag_T;

  ListenFehler : exception;

private
  type Element_Record;
  type Element_Access is access Element_Record;
  type Eintrag_Access is access Eintraege.Eintrag_T;

  type Element_Record is
    record
      eintrag : Eintrag_Access;
      naechstes : Element_Access;
    end record;

  type EinfacheListe_T is
    record
      kopf : Element_Access;
      aktuell : Element_Access;
      laenge : Natural := 0;
    end record;

end EinfacheListen_Ptr;
